/*
 * Copyright 2005-2013 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.springframework.ldap.repository.query;

import org.springframework.ldap.odm.core.impl.UnitTestPerson;
import org.springframework.ldap.repository.LdapRepository;

import java.util.List;

/**
 * @author Mattias Hellborg Arthursson
 */
public interface UnitTestPersonRepository extends LdapRepository<UnitTestPerson> {
    List<UnitTestPerson> findByFullName(String name);
    List<UnitTestPerson> findByFullNameNot(String name);
    List<UnitTestPerson> findByFullNameLike(String name);
    List<UnitTestPerson> findByFullNameNotLike(String name);
    List<UnitTestPerson> findByFullNameStartsWith(String name);
    List<UnitTestPerson> findByFullNameEndsWith(String name);
    List<UnitTestPerson> findByFullNameContains(String name);
    List<UnitTestPerson> findByFullNameGreaterThanEqual(String name);
    List<UnitTestPerson> findByFullNameLessThanEqual(String name);
    List<UnitTestPerson> findByFullNameIsNotNull();
    List<UnitTestPerson> findByFullNameIsNull();

    List<UnitTestPerson> findByFullNameAndLastName(String fullName, String lastName);
    List<UnitTestPerson> findByFullNameAndLastNameNot(String fullName, String lastName);

}
